﻿
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.ServiceModel.Activation;
using System.Text;

namespace DBService  
{
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class DBService:IContract
    {
        public double Add(double x, double y)
        {
            return x+y;
        }

        public string Hello(string mes)
        {
            return "holle word:" + mes;
        }

        public IList<User> getlist()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Name");
            dt.Columns.Add("Age",typeof(System.Int32));
            dt.Rows.Add("joe", "20");
            dt.Rows.Add("ethan", "25");
            dt.Rows.Add("jane", "36");
            IList<User> lst = dt.ToList<User>();
            return lst;
        }

        //public string getlist()
        //{
        //    //为了以统一的方式返回，因为list的类型会比较多，可能为user也可以使dept等等
        //    //这里就是以一个接口返回数据，不管返回的是什么
        //    DataTable dt = new DataTable();
        //    dt.Columns.Add("Name");
        //    dt.Columns.Add("Age", typeof(System.Int32));
        //    dt.Rows.Add("joe", "20");
        //    dt.Rows.Add("ethan", "25");
        //    dt.Rows.Add("jane", "36");
        //   // var command = Newtonsoft.Json.JsonConvert.DeserializeObject<Command>(cmd);
        //    IList<User> lst = dt.ToList<User>();
        //    return Newtonsoft.Json.JsonConvert.SerializeObject(lst);
        //}

        //
    }

  

    public static class Extension
    {
        public static IList<T> ToList<T>(this DataTable dt)
        {
            var lst = new List<T>();
            var plist = new List<System.Reflection.PropertyInfo>(typeof(T).GetProperties());
            foreach (DataRow item in dt.Rows)
            {
                T t = System.Activator.CreateInstance<T>();
                for (int i = 0; i < dt.Columns.Count; i++)
                {
                    PropertyInfo info = plist.Find(p => p.Name == dt.Columns[i].ColumnName);
                    if (info != null)
                    {
                        if (!Convert.IsDBNull(item[i]))
                        {
                            info.SetValue(t, item[i], null);
                        }
                    }
                }
                lst.Add(t);
            }
            return lst;
            ///throw new NotImplementedException();
        }

    }

}
