﻿
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Reflection;
using System.ServiceModel.Activation;
using System.Text;
using IContract;

namespace DBService  
{
    public class DBService:IContract.IContract
    {
        public double Add(double x, double y)
        {
            return x+y;
        }

        public string Hello(string mes)
        {
            return "holle word:" + mes;
        }

        public IList<User> getlist()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Name");
            dt.Columns.Add("Age",typeof(System.Int32));
            dt.Rows.Add("joe", "20");
            dt.Rows.Add("ethan", "25");
            dt.Rows.Add("jane", "36");
            IList<User> lst = dt.ToList<User>();
            return lst;
        }
    }

  

    public static class Extension
    {
        public static IList<T> ToList<T>(this DataTable dt)
        {
            var lst = new List<T>();
            var plist = new List<System.Reflection.PropertyInfo>(typeof(T).GetProperties());
            foreach (DataRow item in dt.Rows)
            {
                T t = System.Activator.CreateInstance<T>();
                for (int i = 0; i < dt.Columns.Count; i++)
                {
                    PropertyInfo info = plist.Find(p => p.Name == dt.Columns[i].ColumnName);
                    if (info != null)
                    {
                        if (!Convert.IsDBNull(item[i]))
                        {
                            info.SetValue(t, item[i], null);
                        }
                    }
                }
                lst.Add(t);
            }
            return lst;
        }

    }

}
