﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="WebAjax.WebForm1" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="js/jquery-1.8.3.min.js"></script>
    <script>
        //1、调用后台方法SayHello
        $(function () {
            $("#btnOK").click(function () {
                $.ajax({
                    //要用post方式      
                    type: "Post",
                    //方法所在页面和方法名      
                    url: "WebForm1.aspx/SayHello",
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (data) {
                        //返回的数据用data.d获取内容      
                        alert(data.d);
                    },
                    error: function (err) {
                        alert(err);
                    }
                });

                //禁用按钮的提交      
                return false;
            });
        });

        //2、调用后台方法获取数据添加到table后面
        $(function () {
            $("#BtnGetList").click(function () {
                $.ajax({
                    //要用post方式      
                    type: "Post",
                    //方法所在页面和方法名      
                    url: "WebForm1.aspx/getlist",
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    success: function (data) {
                        //返回的数据用data.d获取内容 
                        var html = "";
                        $.each(data.d, function (index, item) {
                            var name = item.Name;
                            var age = item.Age;
                            html += "<tr><td>" + name + "</td><td>" + age + "</td></tr>";
                        });
                        $("table tr:eq(0)").after(html);
                    },
                    error: function (err) {
                        alert(err);
                    }
                });

                //禁用按钮的提交      
                return false;
            });
        });


    </script>
</head>
<body>
    <div>
        <button id="btnOK">SayHello to backend</button>
        <button id="BtnGetList">GetList from backend</button>
        <br />
        <br />
        <table id="mytable">
            <tr>
                <td>Name</td>
                <td>Age</td>
            </tr>
            <tr>
                <td>Name</td>
                <td>Age</td>
            </tr>
        </table>
        <br />
        <br />
       
    </div>
</body>
</html>
